---
title: Source mode
slug: MDN/Editor/Source_mode
tags:
  - Guide
  - Intermediate
  - MDN Meta
  - NeedsContent
  - editor
---
<div>{{MDNSidebar}}</div>

<p class="summary">MDN's editor has a prominent button that lets you switch into source editing mode. In this mode, you see the underlying HTML for the body of the article you're editing. <span class="seoSummary">This guide will help you understand what you <strong>can</strong> do with MDN's wiki content source editing mode, what you <strong>should</strong> do with it, and, most importantly, what <strong>not</strong> to do.</span></p>

<div class="notecard warning">
<p>Before you consider using source mode, please note that we <em>strongly</em> urge you not to. Unless what you're doing is something you have to do in order to meet our style guide (we do have required features that unfortunately can't be created without using source mode yet), you shouldn't need to use source mode. See {{anch("Warnings and caveats")}} below.</p>
</div>

<h2 id="Accessing_source_mode">Accessing source mode</h2>

<p>Getting into source mode is easy. At the top-left corner of the editor's toolbar, click the <strong>Source</strong> button.</p>

<p><img alt="Partial screenshot of the editor toolbar, with the Source mode button highlighted" src="https://mdn.mozillademos.org/files/15295/Source%20mode%20button.png" style="height: 98px; width: 267px;"></p>

<p>Due to formatting, images, and the like, it's possible that the source is shorter (vertical length-wise) than the WYSIWYG content that you might need to scroll up to find the source within the <a href="/en-US/docs/MDN/Contribute/Editor/Edit_box">edit box</a>.</p>

<h2 id="Warnings_and_caveats">Warnings and caveats</h2>

<p>As mentioned previously, you rarely need to use source mode. There are a few things you can only do by tweaking the source. Eventually we will update the editing interface to handle those things for you.</p>

<p>Anything that's not expressly described somewhere in the <a href="/en-US/docs/MDN/Contribute">MDN contributor guide</a> should <strong>not</strong> be added to the source. That means:</p>

<ul>
 <li>No custom fonts or styles; if it's not part of our standard look and feel, don't do it.</li>
 <li>No special colors. Use only the colors that are part of the standard look and feel of MDN, provided by the styles we use.</li>
</ul>

<h2 id="Working_in_source_mode">Working in source mode</h2>

<p>When you're in source mode, you're editing the raw HTML that makes up the content of a wiki page. While you're no longer restricted by the editor, you need to do everything you can to make sure your work matches the <a href="/en-US/docs/MDN/Contribute/Guidelines/CSS_style_guide">style guide</a> and that it works safely and reliably.</p>

<div class="notecard note">
<p>You should usually only work in source mode for brief tweaks rather than for an extended period of writing time.</p>
</div>

<p>Unfortunately, the <kbd>Tab</kbd> key doesn't work in our source editor at this time. Insert two spaces for each place where you would normally use the <kbd>Tab</kbd> key.</p>

<p>If you use any HTML elements or attributes that MDN doesn't allow, they're removed from the HTML when your document is saved. In addition, the document's HTML is reformatted to keep it moderately readable and consistent.</p>

<h2 id="Legitimate_uses_for_source_mode">Legitimate uses for source mode</h2>

<p>There are a few cases in which the only way to follow MDN's style guide is to use source mode. This section covers these cases and how to properly implement these features without breaking other things.</p>

<h3 id="Highlighting_lines_in_sample_code">Highlighting lines in sample code</h3>

<p>Within the sample code snippet blocks established by using the <strong>PRE</strong> or <strong>Syntax Highlighter</strong> buttons in <a href="/en-US/docs/MDN/Contribute/Editor/Basics/Toolbar#Blocks_group">the toolbar's block group</a>, you might want to call special attention to lines of code. The only way to do this is to open source mode, find the {{HTMLElement("pre")}} block containing the code, and edit the <code>&lt;pre&gt;</code> tag's {{HTMLAttrxRef("class")}} attribute to include a <code>highlight</code> component formatted as follows:</p>

<ul>
 <li><code>highlight[<em>lineNum1</em>, <em>lineNum2</em>, ..., <em>lineNumN</em>]</code></li>
 <li><code>highlight[<em>lineNumStart</em>-<em>lineNumEnd</em>, ..., <em>lineNumN</em>]</code></li>
</ul>

<pre class="syntaxbox notranslate">"hightlight[" <a href="#highlight-line-number-list">&lt;line-number-list&gt;</a> "]"

<strong>Where:</strong>
<a id="highlight-line-number-list">&lt;line-number-list&gt;</a> = <a href="/en-US/docs/Web/CSS/Value_definition_syntax#Brackets">[</a> <a href="#highlight-line-number">&lt;line-number&gt;</a> <a href="/en-US/docs/Web/CSS/Value_definition_syntax#Single_bar">|</a> <a href="#highlight-line-range">&lt;line-range&gt;</a> <a href="/en-US/docs/Web/CSS/Value_definition_syntax#Brackets">]</a><a href="/en-US/docs/Web/CSS/Value_definition_syntax#Hash_mark">#</a>
<a id="highlight-line-range">&lt;line-range&gt;</a> = <a href="#highlight-line-number">&lt;line-number&gt;</a> - <a href="#highlight-line-number">&lt;line-number&gt;</a>
<a id="highlight-line-number">&lt;line-number&gt;</a> = &lt;number-token&gt;</pre>

<p>For example, if the existing tag is <code>&lt;pre class="brush: js;"&gt;</code>, and you want to add highlighting to lines 4 and 7, you change it to <code>&lt;pre class="brush: js; highlight[4, 7]"&gt;</code>.</p>

<p>Let's look at a more complete example:</p>

<div style="overflow: auto;">
<table class="fullwidth-table">
 <thead>
  <tr>
   <th scope="col">Before highlighting</th>
   <th scope="col">With highlighting</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>
    <pre class="brush: js; notranslate">
var canvas = document.getElementById("canvas");
var ctx = canvas.getContext("2d");

var path1 = new Path2D();
path1.rect(10, 10, 100, 100);

var path2 = new Path2D(path1);
path2.moveTo(220, 60);
path2.arc(170, 60, 50, 0, 2 * Math.PI);

ctx.stroke(path2);
</pre>

    <p>Here, the {{HTMLElement("pre")}} tag is: <code>&lt;pre class="brush: js;"&gt;</code></p>
   </td>
   <td>
    <pre class="brush: js; highlight[4, 7] notranslate">
var canvas = document.getElementById("canvas");
var ctx = canvas.getContext("2d");

var path1 = new Path2D();
path1.rect(10, 10, 100, 100);

var path2 = new Path2D(path1);
path2.moveTo(220, 60);
path2.arc(170, 60, 50, 0, 2 * Math.PI);

ctx.stroke(path2);</pre>

    <p>And here, the <code>&lt;pre&gt;</code> tag has been changed to: <code>&lt;pre class="brush: js; highlight[4, 7]"&gt;</code></p>
   </td>
  </tr>
 </tbody>
</table>
</div>

<h3 id="Styles_that_dont_have_toolbar_buttons">Styles that don't have toolbar buttons</h3>

<p>We have some styles we use on MDN that aren't available using the normal user interface. Fortunately, these aren't used very often. Some examples are:</p>

<ul>
 <li>To apply they "keyboard" style, you need to enclose the text of the key's name in the {{HTMLElement("kbd")}} element. We have no user interface for this yet. So open source mode, and wrap the key name in <code>&lt;kbd&gt;</code>. For example, if the source is:

  <pre class="brush: html; no-line-numbers notranslate">&lt;p&gt;Press the &lt;kbd&gt;Enter&lt;/kbd&gt; key to start the countdown.&lt;/p&gt;</pre>

  <p>The result is:</p>

  <p>Press the <kbd>Enter</kbd> key to start the countdown.</p>
 </li>
 <li>Some uncommon styles used on specialized pages also need to be added by hand. This is common with group boxes. That's why we have macros that help to build many of the landing page components automatically.</li>
</ul>
